---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: undertaker
  labels:
    tier: apps
    daemon: "True"
spec:
  selector:
    matchLabels:
      app: undertaker
  template:
    metadata:
      labels:
        app: undertaker
        tier: apps
        daemon: "True"
    spec:
      serviceAccountName: rucio-kubectl
      volumes:
      - name: rucio-cfg
        configMap:
          name: rucio-cfg
      - name: sshkey
        secret:
          secretName: ssh-key
      - name: proxy-volume
        secret:
          secretName: proxy-cert
          items:
          - key: x509up
            path: x509up
            mode: 0400
          optional: true
      - name: postgresqlcert
        secret:
          secretName: pgssl
          items:
          - key: postgresqlcert.pem
            path: postgresqlcert.pem
            mode: 0444
      - name: postgresqlkey
        secret:
          secretName: pgssl
          items:
          - key: postgresqlkey.pem
            path: postgresqlkey.pem
            mode: 0400
      initContainers:
      - name: proxy-exist
        image: google/cloud-sdk
        command: ["sh", "-c", "until kubectl get secret proxy-cert; do echo Waiting for proxy secret...; sleep 2; done" ]
      - name: postgres-ready
        image: postgres:11
        command: ["sh", "-c", "until pg_isready -h ${RUCIO_DB} -U rucio -p 5432; do echo Waiting for postgresql...; sleep 2; done" ]
        env:
          - name: RUCIO_DB
            valueFrom:
              configMapKeyRef:
                name: rucio-db-hostname
                key: RUCIO_DB
      containers:
      - name: rucio-daemons
        image: containers.ligo.org/rucio/igwn-rucio-kustomize/rucio-daemons:latest
        imagePullPolicy: Always
        resources:
          limits:
            cpu: 1
            memory: 1Gi
          requests:
            cpu: 10m
            memory: 128Mi
        env:
        - name: RUCIO_DB
          valueFrom:
            configMapKeyRef:
              name: rucio-db-hostname
              key: RUCIO_DB
        - name: RUCIO_DAEMON
          value: undertaker
        - name: RUCIO_DAEMON_ARGS
          value: " --total-workers 1 "
#        - name: RUCIO_ENABLE_LOGS
#          value: "True"
        - name: X509_USER_PROXY
          value: /tmp/x509up
        - name: PGSSLCERT
          value: /etc/grid-security/postgresqlcert.pem
        - name: PGSSLKEY
          value: /etc/grid-security/postgresqlkey.pem
        volumeMounts:
        - name: rucio-cfg
          mountPath: /opt/rucio/etc
        - name: proxy-volume
          mountPath: /tmp
        - name: sshkey
          readOnly: true
          #mountPath: /root/.ssh
          mountPath: /home/apache/.ssh
        - name: postgresqlcert
          mountPath: /etc/grid-security/postgresqlcert.pem
          subPath: postgresqlcert.pem
        - name: postgresqlkey
          mountPath: /etc/grid-security/postgresqlkey.pem
          subPath: postgresqlkey.pem
